#ifndef _DECL_MetisLB_H_
#define _DECL_MetisLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group MetisLB: CentralLB{
void MetisLB(void);
};
 */
class MetisLB;
class CProxy_MetisLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_MetisLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_MetisLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    MetisLB* ckLocalBranch(void) {
      return (MetisLB *) CkLocalBranch(_ck_gid);
    }
    static MetisLB* ckLocalBranch(CkGroupID gID) {
      return (MetisLB *) CkLocalBranch(gID);
    }
/* DECLS: void MetisLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_MetisLB(int retEP, CkChareID *cid);
    CProxy_MetisLB(void);
    static int  __idx_MetisLB_void;
    static int  ckIdx_MetisLB(void) { return __idx_MetisLB_void; }
    static void _call_MetisLB_void(void* msg, MetisLB* obj);
};

extern void _registerMetisLB(void);
#endif
